%     AERO LOAD - программа для нагружения агрегатов самолета распределенной нагрузкой
%     Copyright (C) 2018-2024  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Area = Get_Element_Area(Index)

global ErrCode;

global DB_ELEMENTS;
global DB_NODES;

global AT_NODES;

switch DB_ELEMENTS{Index}.N_nodes
    
    case 3
        
        Point_1 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(1))}.Location;
        Point_2 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(2))}.Location;
        Point_3 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(3))}.Location;
        
        Area = Triangle_Area(Point_1, Point_2, Point_3);
        
    case 4
        
        Point_1 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(1))}.Location;
        Point_2 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(2))}.Location;
        Point_3 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(3))}.Location;
        Point_4 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(4))}.Location;
        
        Area = Triangle_Area(Point_1, Point_2, Point_3) + ...
               Triangle_Area(Point_1, Point_3, Point_4);
        
    case 6
        
        Point_1 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(1))}.Location;
        Point_2 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(2))}.Location;
        Point_3 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(3))}.Location;
        Point_4 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(4))}.Location;
        Point_5 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(5))}.Location;
        Point_6 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(6))}.Location;
        
        Area = Triangle_Area(Point_1, Point_4, Point_6) + ...
               Triangle_Area(Point_4, Point_2, Point_5) + ...
               Triangle_Area(Point_6, Point_5, Point_3) + ...
               Triangle_Area(Point_4, Point_5, Point_6);
        
    case 8
        
        Point_1 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(1))}.Location;
        Point_2 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(2))}.Location;
        Point_3 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(3))}.Location;
        Point_4 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(4))}.Location;
        Point_5 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(5))}.Location;
        Point_6 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(6))}.Location;
        Point_7 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(7))}.Location;
        Point_8 = DB_NODES{AT_NODES(DB_ELEMENTS{Index}.Nodes(8))}.Location;
        
        Area = Triangle_Area(Point_1, Point_5, Point_8) + ...
               Triangle_Area(Point_5, Point_2, Point_6) + ...
               Triangle_Area(Point_6, Point_3, Point_7) + ...
               Triangle_Area(Point_7, Point_4, Point_8) + ...
               Triangle_Area(Point_8, Point_5, Point_7) + ...
               Triangle_Area(Point_5, Point_6, Point_7);
        
    otherwise
        
        Area = 0;
        
        fprintf (1, '\nОшибка функции Get_Element_Area: недопустимое число узлов элемента с номером %i !\n', DB_ELEMENTS{Index}.ID);
        ErrCode = -1;
        return;
    
end
